function H = uppropagate(H);

% FUNCTION H = UPPROPAGATE(H);
%
% Uppropagates the responses using the averaging filters.

for f=1:H.F,
 for l=2:H.L,
  % Convolve the responses in the layer below with the filter.
  t = conv2(H.D{l-1,f},H.filt{l-1},'valid');

  % Down sample.
  H.D{l,f} = t(1+floor(H.skipI(l-1)*(0:H.layerI(l)-1)), ...
               1+floor(H.skipJ(l-1)*(0:H.layerJ(l)-1)));
 end;
end;
